/*Client Bulletin Board*/

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<sys/types.h>
#include<sys/ipc.h> 
#include<sys/msg.h> 
#include<iostream.h>
#include<pthread.h>
#include"uconio.h" 
#include"password.cpp"
#include"comp-scomp.cpp"

#define LUN 1024 //Lunghezza Max dei mess. 1024 Caratteri

#define MSGKEYSERVICE1 120 //Chiave canale di servizio di rcv
#define MSGKEYSERVICE2 121 //Chiave canale di servizio di snd

int idservsnd,idservrcv;  //ID dei canali di servizio 


//---- Definisco la struct del messaggio messaggio ----

struct msgform
 {
   int mtype;
   char mtext[LUN];
 };

struct msgctrl
{
  int mtype;
  char mtext;
};


/*
----------------NOTA BENE---------------
 mtext=  significa richiesta connessione 
 mtext=  significa risposta ok server
 mtext=  corrisponde al testo dell'idsnd
 mtext=  corrisponde al testo dell'idrcv
 mtext= ! equivale a messaggio di errore   
*/

//Id dei ch di rcv e snd
int Idch1,Idch2;

//funz. di servizio
void * service(void *); 


//funz. di interfaccia
void Mascherina();
void Menu();
void Menu_Utente();
void Menu_Aggiornamento();
void About();
int Centra(char parola[])
{
 return((80/2)-(strlen(parola)/2));
}


// DICHIARAZIONE DELLE VARIABILI DI INTERFACCIA
char Titolo[]="-BULLETIN BOARD-";
char Descrizione[]="Progetto e Sviluppo di Capuano V. - Meli M. -  Scognamiglio A.";

//funz. di gestione operazioni interfaccia
void Servizio1();
void Servizio2();
void Servizio3();
void Servizio4();
void Servizio5();
void Servizio6();



void main()
{
 //def. thread di servizio		
 pthread_t ths;
 
 idservrcv=msgget(MSGKEYSERVICE1,0777|IPC_CREAT);
 idservsnd=msgget(MSGKEYSERVICE2,0777|IPC_CREAT);
 
 if (idservsnd>-1 && idservrcv>-1)
 {               
  //controllo thread di servizio
  pthread_create(&ths,NULL,service,NULL);

  //attesa fine thread 
  pthread_join(ths,NULL);

  //disalloco i ch di snd e rcv
  msgctl(Idch1,IPC_RMID,NULL);
  msgctl(Idch2,IPC_RMID,NULL);
 }
 else
 {
  cout<<"FATAL ERROR service ch"<<endl;
 }
}


void * service(void *)
{
 int test; char tasto;
 msgctrl richiesta,risposta,nch1,nch2;
 
 //richiesta connessione al server
 richiesta.mtype=1;
 richiesta.mtext= '';
 
 msgsnd(idservsnd,&richiesta,sizeof(richiesta.mtext),0);  
 cout<<"\n Ho inviato richiesta di connessione"<<endl; 
 test=msgrcv(idservrcv,&risposta,sizeof(risposta.mtext),1,0);
 if(test!=-1 && risposta.mtext=='')
  {
   cout<<"\n Ho ricevuto risposta OK"<<endl;
   //Il server ha ricevuto la richiesta correttamente
   test=msgrcv(idservrcv,&nch1,sizeof(nch1.mtext),0,0);
   cout<<"\n Ho ricevuto la chiave di ch "<<nch1.mtype<<endl;
   if(test!=-1 && nch1.mtext=='')
   {
	 test=msgrcv(idservrcv,&nch2,sizeof(nch2.mtext),0,0);
	 cout<<"\n Ho ricevuto la chiave di ch "<<nch2.mtype<<endl;
	 if(test!=-1 && nch2.mtext=='')
	 {
	  //Id ch di snd
	  Idch1 = msgget(nch1.mtype,0777|IPC_CREAT);
	  //Id ch di rcv
	  Idch2 = msgget(nch2.mtype,0777|IPC_CREAT);
      
	  cout<<"\n Mi sono attaccato sui canali: "<<nch1.mtype<<" e "<<nch2.mtype<<endl;  

	  cout<<"\n...ho ricevuto tutto..."<<endl;
	  
	  cout<<"\ndigita un tasto per continuare...";
	  tasto=u_getch();
      
	  //lancio la funzione che consente la scelta
	  //di essere un semplice utente o un manager
	  Menu();
	  
	  cout<<"\n...ho concluso..."<<endl;
	 }
    }
   }
}

void Menu()
{
 char tasto;
 char a;
 int control=0; 
 int control1=0;
 
 do
 {
	u_clrscr();
	u_gotoxy(Centra(Titolo),1);
	cout<<Titolo;
	u_gotoxy(Centra(Descrizione),3);
	cout<<Descrizione;
	Mascherina();
	u_gotoxy(Centra("MENU PRINCIPALE"),7);
	cout<<"MENU PRINCIPALE";
	// Visualizzazione Opzioni
	u_gotoxy(7,10);
	cout<<"1) Sessione Utente";
	u_gotoxy(7,12);
	cout<<"2) Aggiornamento Notizie";
	u_gotoxy(7,14);
	cout<<"3) Informazioni su...";
	u_gotoxy(7,16);
	cout<<"ESC) Termina Sessione\n\n\n\n";
	 // Pressione Tasto
	tasto=u_getch();
	// Riconoscimento del Tasto
	switch(tasto)
	{
	  case '1':
	     Menu_Utente();
		 tasto=27;
		 break;
	  case '2':
	     do
	     {
	      controllo(control);
	      if(control==0)
	      { 
	         Menu_Aggiornamento();
	         control=3;
	         control1=1;
	      }
	     }while(control<3);
		 if(control1==0)
		 {
		  cout<<"\nVuoi continuare come Utente? (si=s): ";
		  a=u_getch();
		  if(a=='s')
		   Menu_Utente();
		  else
		   cout<<"\n<CIAO!>\n\n";
		 }
	     tasto=27;
		 break;
	  case '3':
	     About();
		 break;
	  case '@':
	     mostra_psw();
		 break;
	  default:
	     break;
	}
 }while(tasto!=27); // Termina con ESC
}


void Mascherina()
{
 int i;
 for(i=3;i<76;i++)
 {
  u_gotoxy(i,6); cout<<"*";
  u_gotoxy(i,18); cout<<"*";
 }
 for(i=3;i<75;i+=2)
 {
  u_gotoxy(i,8); cout<<"*";
 }
 for(i=6;i<18;i++)
 {
  u_gotoxy(3,i); cout<<"*";
  u_gotoxy(75,i); cout<<"*";
 }
}


void Menu_Utente()
{
 char tasto;
 do
 {
  u_clrscr();
  u_gotoxy(Centra(Titolo),1);
  cout<<Titolo;
  u_gotoxy(Centra(Descrizione),3);
  cout<<Descrizione;
  Mascherina();
  u_gotoxy(Centra("MENU UTENTE"),7);
  cout<<"MENU UTENTE";
  // Visualizzazione Opzioni
  u_gotoxy(7,10);
  cout<<"1) Leggi Notizia per Pagina";
  u_gotoxy(7,12);
  cout<<"2) Leggi Notizia per Argomento";
  u_gotoxy(7,14);
  cout<<"3) Visualizza Argomenti in Memoria";
  u_gotoxy(7,16);
  cout<<"ESC) Termina Sessione\n\n\n\n";
  // Pressione Tasto
  tasto=u_getch();
  // Riconoscimento del Tasto
  switch(tasto)
  {
    case '1':
	 Servizio1();
	 break;
    case '2':
	 Servizio2();
	 break;
	case '3':
	 Servizio3();
	 break;
	default:
	 break;
  }
 }while(tasto!=27); // Termina con ESC
}


void Menu_Aggiornamento()
{
 char tasto;
 do
 {
  u_clrscr();
  u_gotoxy(Centra(Titolo),1);
  cout<<Titolo;
  u_gotoxy(Centra(Descrizione),3);
  cout<<Descrizione;
  Mascherina();
  u_gotoxy(Centra("MENU AGGIORNAMENTO"),7);
  cout<<"MENU AGGIORNAMENTO";
  // Visualizzazione Opzioni
  u_gotoxy(7,10);
  cout<<"1) Leggi Notizia per Pagina";
  u_gotoxy(7,11);
  cout<<"2) Leggi Notizia per Argomento";
  u_gotoxy(7,12);
  cout<<"3) Visualizza Argomenti in Memoria";
  u_gotoxy(7,13);
  cout<<"4) Aggiunta di una Notizia";
  u_gotoxy(7,14);
  cout<<"5) Cancellazione di una Notizia";
  u_gotoxy(7,15);
  cout<<"6) Reset del Sistema";
  u_gotoxy(7,16);
  cout<<"ESC) Termina Sessione\n\n\n\n";
  // Pressione Tasto
  tasto=u_getch();
  // Riconoscimento del Tasto
  switch(tasto)
  {
   case '1':
    Servizio1();
    break;
   case '2':
    Servizio2();
    break;
   case '3':
    Servizio3();
	break;
   case '4':
    Servizio4();
	break;
   case '5':
    Servizio5();
    break;
   case '6':
    Servizio6();
	break;
  }
 }while(tasto!=27); // Termina con ESC
}

void About()
{
 FILE *file;
 char infor[256];
 u_clrscr();
 u_gotoxy(Centra(Titolo),1);
 cout<<Titolo;
 u_gotoxy(Centra(Descrizione),3);
 cout<<Descrizione;
 u_gotoxy(Centra("Informazioni su..."),7);
 cout<<"About";
 strcpy(infor,"info.txt");
 file=fopen(infor,"r");
 while(!feof(file))
 {
  fgets(infor,256,file);
  cout<<infor;
 }
 fclose(file);
 u_getch();
}

//leggi notizia per pagina
void Servizio1() 
{
 msgctrl risposta1,risposta2,scelta,pos;
 msgform notizia;
 struttura news; //il tipo struttura e' def. in comp-scomp.cpp
 int test; char tasto;
 int control=0;
 
 scelta.mtype= 2;
 scelta.mtext= '1';
 msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);
 
 test=msgrcv(Idch2,&risposta1,sizeof(risposta1.mtext),1,0);
 if (test!=-1 && risposta1.mtext=='')
  {          
   pos.mtext='p';
   cout<<"\n Digita posizione notizia: ";
   cin>>pos.mtype;
   msgsnd(Idch1,&pos,sizeof(pos.mtext),0);
   
   msgrcv(Idch2,&risposta2,sizeof(risposta2.mtext),0,0);
   
   if(risposta2.mtext=='')
   { 
    //---mi appresto a prelevare i dati---
    msgrcv(Idch2,&notizia,sizeof(notizia.mtext),4,0);
	
	strsco(notizia.mtext,news);
    //--stampo la notizia---
	cout<<"\nArgomento: "<<news.nome1<<endl;
	cout<<"\nNotizia  : "<<news.nome2<<endl;
	
	control=1;
   }
   
   if(risposta2.mtext=='!');
	cout<<"\nLa posizione digitata non corrisponde ad alcuna notizia!"<<endl;
  }
  
  if(test!=-1 && risposta1.mtext=='!')
	cout<<"\nErrore trasmissione dati";
  
  tasto=u_getch();
  cout<<"\ndigita un tasto per continuare...";
  tasto=u_getch();
  
}


//leggi notizia per argomento
void Servizio2() 
{
 msgctrl scelta,risposta1,risposta2;
 msgform nome,notizia;
 struttura news;
 int test; char tasto;
 int control=0;
 
 scelta.mtype= 2;
 scelta.mtext= '2';
 msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);
 
 test=msgrcv(Idch2,&risposta1,sizeof(risposta1.mtext),1,0);
 if(test!=-1 && risposta1.mtext=='')
 {
  nome.mtype=3;
  cout<<"\n Digita nome notizia: ";
  gets(nome.mtext);
  msgsnd(Idch1,&nome,sizeof(nome.mtext),0);
  		   
  msgrcv(Idch2,&risposta2,sizeof(risposta2.mtext),0,0);
 
  if(risposta2.mtext=='')
  {
   //---mi appresto a prelevare i dati---
   msgrcv(Idch2,&notizia,sizeof(notizia.mtext),4,0);
					
   strsco(notizia.mtext,news);
   //--stampo la notizia---
   cout<<"\nArgomento: "<<news.nome1<<endl;
   cout<<"\nNotizia  : "<<news.nome2<<endl;
   
   control=1;
  }

  if(control==0/*risposta2.mtext=='!'*/);
   cout<<"\nNotizia Inesistente!"<<endl;
 }

 if(test!=-1 && risposta1.mtext=='!')
  cout<<"\nErrore trasmissione dati";

 cout<<"\ndigita un tasto per continuare...";
 tasto=u_getch();
 
}

//stampa argomenti presenti in memoria
void Servizio3() 
{
 char name[100][512],tasto;
 msgctrl risposta1,risposta2,scelta;
 msgform argomenti;
 int test,i,n;
 
 scelta.mtype= 2;
 scelta.mtext= '3';
 msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);
 
 test=msgrcv(Idch2,&risposta1,sizeof(risposta1.mtext),1,0); 
 if(test!=-1 && risposta1.mtext=='')
 {
  test=msgrcv(Idch2,&risposta2,sizeof(risposta2.mtext),1,0);
  if(test!=-1 && risposta2.mtext=='')
  {
   msgrcv(Idch2,&argomenti,sizeof(argomenti.mtext),3,0);
   
   strsco2(argomenti.mtext,name,n);
   
   for(i=0;i<n;i++)
    cout<<"Notizia "<<(i+1)<<"... "<<name[i]<<endl;
  }
  if(test!=-1 && risposta2.mtext=='!')
   cout<<flush<<"\n<MEMORIA VUOTA!>";
 }
 
 if(test!=-1 && risposta1.mtext=='!')
  cout<<"\nErrore trasmissione dati";
  
 cout<<"\ndigita un tasto per continuare...";
 tasto=u_getch();
	
}

//aggiunta di una notizia
void Servizio4() 
{
 msgform notizia;
 msgctrl scelta,risposta;
 int test; char tasto;
 struttura news; tex A;
 
 scelta.mtype= 2;
 scelta.mtext= '4';
 msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);

 test=msgrcv(Idch2,&risposta,sizeof(risposta.mtext),1,0);
 if(test!=-1 && risposta.mtext=='')
 {
  /* Richiesta dei dati da inserire */

  cout<<"\nInserisci l'argomento:"<<flush;
  gets(news.nome1);

  cout<<"\nInserisci la notizia:"<<flush;
  gets(news.nome2);
	 
  strco(news,A);
  notizia.mtext=A;
  notizia.mtype=3;
  msgsnd(Idch1,&notizia,sizeof(notizia.mtext),0);
  cout<<flush<<"\n Ho inviato... "<<notizia.mtext;
 }

 if(test!=-1 && risposta.mtext=='!')
  cout<<"\nErrore trasmissione dati";

 cout<<"\ndigita un tasto per continuare...";
 tasto=u_getch();
 
}

//cancellazione di una notizia
void Servizio5() 
{
 msgctrl scelta,risposta1,risposta2,pos;
 int test; char tasto;
 
 scelta.mtype= 2;
 scelta.mtext= '5';
 msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);
 
 test=msgrcv(Idch2,&risposta1,sizeof(risposta1.mtext),1,0);
 if(test!=-1 && risposta1.mtext=='')
 {
  pos.mtext='p';
  cout<<"\nInserisci la posizione della notizia da cancellare:"<<flush;
  cin>>pos.mtype;
  
  msgsnd(Idch1,&pos,sizeof(pos.mtext),0);

  msgrcv(Idch2,&risposta2,sizeof(risposta2.mtext),0,0);
  
  if(risposta2.mtext=='')
    cout<<"Notizia cancellata!"<<endl;

  if(risposta2.mtext=='!')
    cout<<"\nLa posizione digitata non corrisponde ad alcuna notizia!"<<endl;
 }

 if(test!=-1 && risposta1.mtext=='!')
  cout<<"\nErrore trasmissione dati";
 
 cout<<"\ndigita un tasto per continuare...";
 tasto=u_getch();
 
}


//reset della memoria
void Servizio6() 
{
 msgctrl richiesta,risposta1,risposta2,scelta;
 int test;
 char a,tasto;
 
 cout<<"Sei sicuro di voler resettare la memoria? (s/n): ";
 cin>>a;
 if(a=='s')
 {
  scelta.mtype= 2;
  scelta.mtext= '6';
  msgsnd(Idch1,&scelta,sizeof(scelta.mtext),0);
 
  cout<<flush<<"\nHo inviato la richiesta";

  test=msgrcv(Idch2,&risposta1,sizeof(risposta1.mtext),1,0);
  
  if (test!=-1 && risposta1.mtext=='')
  {
   msgrcv(Idch2,&risposta2,sizeof(risposta2.mtext),0,0);
   cout<<flush<<"\n Ho ricevuto... "<<risposta2.mtext;
   
   if (risposta2.mtext=='')
    cout<<"\n<Memoria vouta!>"<<endl;
  } 
  
  if(risposta1.mtext=='!')
   cout<<"\nErrore trasmissione dati";
 } 
 
 cout<<"\ndigita un tasto per continuare...";
 tasto=u_getch();
 
}

